;===================================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

printf MACRO format:REQ, args:VARARG
    IFNB <args>
        invoke crt_printf, cfm$(format), args
    ELSE
        invoke crt_printf, cfm$(format)
    ENDIF
    EXITM <>
ENDM

;==============================================================================

showstack MACRO
    cls
    mov ebx, startESP
    .WHILE ebx >= esp
        mov eax, [ebx]
        printf( "%Xh\t%08Xh\n", ebx, eax )
        sub ebx, 4
    .ENDW
    getkey
ENDM

;==============================================================================
    .data
        startESP dd 0
    .code
;==============================================================================
start:
;==============================================================================
    push -1
    mov startESP, esp
    showstack

    N=0
    REPEAT 16
      push N
      showstack
      N=N+1
    ENDM
    REPEAT 16
      pop eax
      showstack
    ENDM

    inkey "Press any key to exit..."
    exit

;==============================================================================
end start
